//+--------------------------------------------------------------------------------------------+
//|                                                                                WNV_v2.mq4 |
//|                                            Copyright  2007, Test EA for WNV by Tradinator |
//|http://www.forex-tsd.com/expert-advisors-metatrader-4/5861-wanted-ea-very-simple-system.html|
//|                                            Fixed by Igorad, E-mail: igorad2003@yahoo.co.uk |
//|                                      http://finance.groups.yahoo.com/group/TrendLaboratory |
//+--------------------------------------------------------------------------------------------+
#property copyright "Copyright  2007, Test EA for WNV by Tradinator"
#property link      "http://www.forex-tsd.com/expert-advisors-metatrader-4/5861-wanted-ea-very-simple-system.html"

extern string ExpertName             = "WNV_v2";
extern int MagicNumber               = 0;
extern double Lots                   = 0.1;
extern int    StopLoss               = 50;
extern int    TakeProfit             = 100;

extern bool   Long_Entry             = true;   // Set to "true" or "false".
extern bool   Short_Entry            = false;  // You can have both Long_Entry & Short Entry set to "true".
extern int    Hour_For_Long_Entry    = 16;     //this is your broker's time as displayed in the MArket Watch window.
extern int    Minute_For_Long_Entry  = 35;
extern int    Hour_For_Short_Entry   = 9;      //this is your broker's time as displayed in the Market Watch window.
extern int    Minute_For_Short_Entry  = 53;

extern int    Slippage               = 5;
extern bool   MM                     = false;  //  Switch
extern double MaxRisk                = 0.05;   // Maximum Risk Factor (5% by default)


int bDate, sDate;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   if (Symbol()=="AUDCADm" || Symbol()=="AUDCAD") {MagicNumber=101;}
   if (Symbol()=="AUDCHFm" || Symbol()=="AUDCHF") {MagicNumber=102;}
   if (Symbol()=="AUDJPYm" || Symbol()=="AUDJPY") {MagicNumber=103;}
   if (Symbol()=="AUDNZDm" || Symbol()=="AUDNZD") {MagicNumber=104;}
   if (Symbol()=="AUDUSDm" || Symbol()=="AUDUSD") {MagicNumber=105;}
   if (Symbol()=="CADCHFm" || Symbol()=="CADCHF") {MagicNumber=106;}
   if (Symbol()=="CADJPYm" || Symbol()=="CADJPY") {MagicNumber=107;}
   if (Symbol()=="CHFJPYm" || Symbol()=="CHFJPY") {MagicNumber=108;}
   if (Symbol()=="EURAUDm" || Symbol()=="EURAUD") {MagicNumber=109;}
   if (Symbol()=="EURCADm" || Symbol()=="EURCAD") {MagicNumber=110;}
   if (Symbol()=="EURCHFm" || Symbol()=="EURCHF") {MagicNumber=111;}
   if (Symbol()=="EURGBPm" || Symbol()=="EURGBP") {MagicNumber=112;}
   if (Symbol()=="EURJPYm" || Symbol()=="EURJPY") {MagicNumber=113;}
   if (Symbol()=="EURUSDm" || Symbol()=="EURUSD") {MagicNumber=114;}
   if (Symbol()=="EURNZdm" || Symbol()=="EURNZD") {MagicNumber=115;}
   if (Symbol()=="GBPAUDm" || Symbol()=="GBPAUD") {MagicNumber=116;} 
   if (Symbol()=="GBPCADm" || Symbol()=="GBPCAD") {MagicNumber=117;} 
   if (Symbol()=="GBPCHFm" || Symbol()=="GBPCHF") {MagicNumber=118;}   
   if (Symbol()=="GBPJPYm" || Symbol()=="GBPJPY") {MagicNumber=119;}
   if (Symbol()=="GBPNZDm" || Symbol()=="GBPNZD") {MagicNumber=120;}
   if (Symbol()=="GBPUSDm" || Symbol()=="GBPUSD") {MagicNumber=121;}
   if (Symbol()=="NZDCADm" || Symbol()=="NZDCAD") {MagicNumber=122;}
   if (Symbol()=="NZDCHFm" || Symbol()=="NZDCHF") {MagicNumber=123;}
   if (Symbol()=="NZDJPYm" || Symbol()=="NZDJPY") {MagicNumber=124;}
   if (Symbol()=="NZDUSDm" || Symbol()=="NZDUSD") {MagicNumber=125;}
   if (Symbol()=="USDCHFm" || Symbol()=="USDCHF") {MagicNumber=126;}
   if (Symbol()=="USDJPYm" || Symbol()=="USDJPY") {MagicNumber=127;}
   if (Symbol()=="USDCADm" || Symbol()=="USDCAD") {MagicNumber=128;}
   if (Symbol()=="USDMXNm" || Symbol()=="USDMXN") {MagicNumber=129;}
   if (MagicNumber==0) {MagicNumber = 199;}    
   
//----
   return(0);
  }
  
int ScanTrades(int mode)
{   
   int total = OrdersTotal();
   int numords = 0;
   bool type = false; 
   
   
   for(int cnt=0; cnt<total; cnt++) 
   {        
   OrderSelect(cnt, SELECT_BY_POS);            
   if (mode == 0) type = OrderType()<=OP_SELLSTOP;
   if (mode == 1) type = OrderType()<=OP_SELL;   
   if (mode == 2) type = OrderType()>OP_SELL && OrderType()<=OP_SELLSTOP; 
   
   if(OrderSymbol() == Symbol() && type && OrderMagicNumber() == MagicNumber)  
   numords++;
   }
   return(numords);
}  
//---- Calculation of Position Volume
double MoneyManagement()
{
   double lot_min =MarketInfo(Symbol(),MODE_MINLOT);
   double lot_max =MarketInfo(Symbol(),MODE_MAXLOT);
   double lot_step=MarketInfo(Symbol(),MODE_LOTSTEP);
   double contract=MarketInfo(Symbol(),MODE_LOTSIZE);
   double vol;
//--- check data
   if(lot_min<0 || lot_max<=0.0 || lot_step<=0.0) 
   {
   Print("CalculateVolume: invalid MarketInfo() results [",lot_min,",",lot_max,",",lot_step,"]");
   return(0);
   }
   if(AccountLeverage()<=0)
   {
   Print("CalculateVolume: invalid AccountLeverage() [",AccountLeverage(),"]");
   return(0);
   }
//--- basic formula
   if ( MM )
   vol=NormalizeDouble(AccountFreeMargin()*MaxRisk*AccountLeverage()/contract,2);
   else
   vol=Lots;
//--- check min, max and step
   vol=NormalizeDouble(vol/lot_step,0)*lot_step;
   if(vol<lot_min) vol=lot_min;
   if(vol>lot_max) vol=lot_max;
//---
   return(vol);
}     
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
//----
   if(!IsTradeAllowed()) {Print("Trade not allowed");return(0);}
   
   int CurrDate = TimeDay(TimeCurrent());
    
   if(ScanTrades(0)==0)
   {      
      if(Long_Entry && Hour()==Hour_For_Long_Entry && Minute()>=Minute_For_Long_Entry && CurrDate != bDate)
      {
      int bTicket = OrderSend(Symbol(),OP_BUY,MoneyManagement(),
                              NormalizeDouble(Ask,Digits),
                              Slippage,
                              NormalizeDouble(Ask-StopLoss*Point,Digits),
                              NormalizeDouble(Ask+TakeProfit*Point,Digits),
                              ExpertName+" Buy",MagicNumber,0,Blue); 
      
      if (bTicket > 0) bDate = CurrDate;  
      }        
   
      if(Short_Entry && Hour()==Hour_For_Short_Entry && Minute()>=Minute_For_Short_Entry && CurrDate != sDate)
      {
      int sTicket = OrderSend(Symbol(),OP_SELL,MoneyManagement(),
                              NormalizeDouble(Bid,Digits),
                              Slippage,
                              NormalizeDouble(Bid+StopLoss*Point,Digits),
                              NormalizeDouble(Bid-TakeProfit*Point,Digits),
                              ExpertName+" Sell",MagicNumber,0,Red);
      if (sTicket > 0) sDate = CurrDate; 
      } 
   }
//----
   return(0);
}
//+------------------------------------------------------------------+